<template>
  <div class="comments">

    <form class="comments__form" method="post">
      <label class="form__label" for="post-title">Comentar</label>
      <textarea class="form__textarea" name="post-content" placeholder="Lorem ipsum dolor sit amet, consectetur adipisicing elit. Nam fugiat cupiditate minima ab? Illum adipisci itaque, nisi consequatur ea libero!"></textarea>
      <button class="comments__form-btn" name="comment-button" v-on:click="createComment">Enviar</button>
    </form>

    <div class="comments__item" v-for="comment in comments" v-bind:key="comment.id">
      <div class="comments__item-title">
        <div class="comments__item-author">Comentário de {{comment.author}}</div>
        <div class="comments__item-date">criado as {{comment.timestamp}}</div>
      </div>

      <div class="comments__item-body">
        {{comment.body}}
      </div>
    </div>

  </div>
</template>

<style>

  .comments__form-btn {
    @apply bg-gray-300 rounded-full pb-2 pt-2 pl-5 pr-5 rounded-full outline-none;
  }

  .comments__form {
    @apply mt-5 mb-10 p-10 shadow w-full bg-white text-left;
  }

  .form__textarea {
    @apply mb-5 pt-2 pb-2 pl-5 pr-5 border-solid border border-gray-400 w-full outline-none;
  }

  .form__label {
    @apply block mt-3 mb-5 pb-1 border-b border-gray-400 text-xl font-bold uppercase;
  }

  .comments__item-title {
    @apply flex mt-3 mb-5 pb-1 border-b border-gray-400 text-xl font-bold uppercase;
  }

  .comments__item-author,
  .comments__item-date {
    width: 50%;
  }

  .comments__item-date {
    color: #b6b6b6;
    font-size: 14px;
    text-align: right;
  }

  .comments__item {
    @apply mt-5 mb-10 p-10 shadow w-full bg-white text-left;
  }

  @media screen and (max-width: 600px) {

    .comments__item-title {
      display: block;
    }

    .comments__item-author,
    .comments__item-date {
      width: 100%;
      text-align: left;
    }

    .comments__item-date  {
      margin: 15px auto 0;
    }

  }
</style>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import axios from 'axios';

@Component
export default class PostComments extends Vue {

  public data() {
    return {
      comments: [],
    };
  }

  public async createComment(e) {
    e.preventDefault();

    const commentContent = document.querySelector('.form__textarea');
    const postDate = new Date();
    const hour = '' + postDate.getHours() + ':' + postDate.getMinutes();
    const date = '' + postDate.getDate() + '/' + postDate.getMonth() + '/' + postDate.getFullYear() + '';
    const postDateFormated = '' + hour + ' ' + date;

    const postID = (this.$route.params.id);

    const result = await axios({
      url: 'http://localhost:4020/graphql',
      method: 'post',
      data: {
          query: `
            mutation createComment{
                createComment(
                  data:
                  {
                    body: "${commentContent.value}"
                    author: "user_id",post: "${postID}"
                    likes: 0
                    timestamp: "${postDateFormated}"
                  }
                ){
                  _id
                  body
                  post
                  author
                  likes
                  timestamp
                }
            }`,
      },
    });

    this.showComments();
    commentContent.value = '';
  }

  public async showComments() {

    const idpost = '' + (this.$route.params.id) + '';
    const result = await axios({
        method: 'POST',
        url: 'http://localhost:4020/graphql',
        data: {
              query: `
                  {
                    getPostComments(
                      post: "${idpost}"
                    ){
                      body
                      author
                      timestamp
                    }
                  }
              `,
          },
      });

    this.comments = result.data.data.getPostComments;

    } public catch(error: any) {
        return error;
    }

    public mounted() {
      this.showComments();
    }
  }
</script>
